﻿<?php
/**
Plugin Name: WP COinS
Plugin URI: http://www.diplod.it/
Description: Questo plugin inserisce il codice per il riconoscimento degli articoli da parte dei software che utilizzano lo standard COinS (come Zotero: http://www.zotero.org/)
Author: Davide Del Monte
Author URI: http://www.diplod.it/
 */

function dd_coins_head() {

  if( is_single() ) {
	$css = "\n<style type='text/css'>";
	$css .= "span.Z3988 { display:none; }";
	$css .= "</style>\n";

	echo $css;
	}
}

function dd_coins_content($content) {
	global $post;
	
	if (is_single()) {
		
		$ctx_ver = 'Z39.88-2004';
		$string_permalink = get_permalink();
		$rfr_id	= htmlentities($string_permalink);
		$rft_val_fmt = htmlentities('info:ofi/fmt:kev:mtx:dc');
		
		$string_title = get_the_title('', '', false);
		$rft_title = htmlentities($string_title);
		$rft_title = str_replace(' ', '+', $rft_title);
		
		$string_aulast = get_the_author_lastname();
		$string_aufirst = get_the_author_firstname();
		$rft_aulast	= htmlentities($string_aulast);
		$rft_aufirst = htmlentities($string_aufirst);
		$rft_aulast = str_replace(' ', '+', $rft_aulast);
		$rft_aufirst = str_replace(' ', '+', $rft_aufirst);
		
		$string_description = 'Articolo dal blog '.get_bloginfo('name');
		$rft_description = htmlentities($string_description);
		$rft_description = str_replace(' ', '+', $rft_description);
		
		//$rft_publisher = htmlentities($string_publisher);
		//$rft_publisher = str_replace(' ', '+', $rft_publisher);
		
		$rft_date = get_the_time("Y-m-d"); //2008-04-17
		
		$rft_type = 'blogPost';
		
		$string_source = get_bloginfo('name');
		$rft_source	= htmlentities($string_source);
		$rft_language = 'italiano';
		
		foreach((get_the_category()) as $cat) {
			$cats = $cats . "&amp;rft.subject=" . urlencode($cat->cat_name);
			}
		
		$content = $content.'<span class="Z3988" title="ctx_ver='.$ctx_ver.'&amp;rft_val_fmt='.$rft_val_fmt.'&amp;rfr_id='.$rfr_id.'&amp;rft.title='.$rft_title.'&amp;rft.aulast='.$rft_aulast.'&amp;rft.aufirst='.$rft_aufirst.'&amp;rft.description='.$rft_description.$cats.'&amp;rft.date='.$rft_date.'&amp;rft.type='.$rft_type.'&amp;rft.source='.$rft_source.'&amp;rft.format=text&amp;rft.identifier='.$rfr_id.'&amp;rft.language='.$rft_language.'"><a href="'.$string_permalink.'" title="permalink">'.$string_title.'</a></span>';
		
	}
	return $content;
}

add_action('wp_head', 'dd_coins_head');
add_filter('the_content', 'dd_coins_content');
?>